# remirepo/Fedora spec file for php-zendframework-zend-expressive-router
#
# Copyright (c) 2016-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    14f8e8e1ca6a0469779d9df2c569f420fc41bd01
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-expressive-router
%global php_home     %{_datadir}/php
%global library      Expressive
%global sublib       Router
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.0.0
Release:        7%{?dist}
Summary:        %{sublib} subcomponent for %{library}

License:        BSD
URL:            https://framework.zend.com/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-composer(psr/http-message)                    >= 1.0
BuildRequires:  php-composer(fig/http-message-util)               >= 1.1
BuildRequires:  php-pcre
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^4.7 || ^5.6",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "malukenho/docheader": "^0.1.5"
BuildRequires:  php-composer(phpunit/phpunit)                     >= 4.7
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "psr/http-message": "^1.0",
#        "fig/http-message-util": "^1.1"
Requires:       php(language) >= 5.6
Requires:       php-composer(psr/http-message)                    >= 1.0
Requires:       php-composer(psr/http-message)                    <  2
Requires:       php-composer(fig/http-message-util)               >= 1.1
Requires:       php-composer(fig/http-message-util)               <  2
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.2.0
Requires:       php-pcre
Requires:       php-spl
%if ! %{bootstrap}
# From composer, "suggest": {
#        "zendframework/zend-expressive-aurarouter": "^1.0 to use the Aura.Router routing adapter",
#        "zendframework/zend-expressive-fastroute": "^1.2 to use the FastRoute routing adapter",
#        "zendframework/zend-expressive-zendrouter": "^1.2 to use the zend-router routing adapter"
%if 0%{?fedora} >= 21
Suggests:       php-autoloader(%{gh_owner}/zend-expressive-aurarouter)
Suggests:       php-autoloader(%{gh_owner}/zend-expressive-fastroute)
Suggests:       php-autoloader(%{gh_owner}/zend-expressive-zendrouter)
%endif
%endif

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Router subcomponent for Expressive.

This package provides the following classes and interfaces:

* RouterInterface, a generic interface to implement for providing routing
  capabilities around PSR-7 ServerRequest messages.
* Route, a value object describing routed middleware.
* RouteResult, a value object describing the results of routing.

We currently support and provide the following routing integrations:

* Aura.Router: php-zendframework-zend-expressive-aurarouter
* FastRoute: php-zendframework-zend-expressive-fastroute
* ZF2 MVC Router: php-zendframework-zend-expressive-zendviewrouter

Documentation: http://zend-expressive.readthedocs.io/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create dependency autoloader - deprecated
cat << 'EOF' | tee autoload.php
<?php
require_once '%{php_home}/Fig/Http/Message/autoload.php';
EOF

: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Psr/Http/Message/autoload.php',
    '%{php_home}/Fig/Http/Message/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/%{library}/%{sublib}/aurarouter-autoload.php',
    '%{php_home}/Zend/%{library}/%{sublib}/fastroute-autoload.php',
    '%{php_home}/Zend/%{library}/%{sublib}/zendrouterautoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/%{library}
cp -pr src %{buildroot}%{php_home}/Zend/%{library}/%{sublib}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/%{library}-%{sublib}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/%{sublib}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\%{sublib}', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php56 php70 php71 php72; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%dir %{php_home}/Zend
%dir %{php_home}/Zend/%{library}/
     %{php_home}/Zend/%{library}/%{sublib}/
     %{php_home}/Zend/%{library}-%{sublib}-autoload.php


%changelog
* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Dec 11 2017 Remi Collet <remi@remirepo.net> - 2.0.0-3
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue Feb 14 2017 Remi Collet <remi@fedoraproject.org> - 2.0.0-1
- update to 2.0.0

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Dec 14 2016 Remi Collet <remi@fedoraproject.org> - 1.3.2-1
- update to 1.3.2
- raise dependency on PHP 5.6
- add dependency on fig/http-message-util

* Sat Jul  2 2016 Remi Collet <remi@fedoraproject.org> - 1.2.0-2
- drop autoloader, rely on zend-loader >= 2.5.1-4

* Sat Jul  2 2016 Remi Collet <remi@fedoraproject.org> - 1.2.0-2
- drop autoloader, rely on zend-loader >= 2.5.1-4

* Fri Jul  1 2016 Remi Collet <remi@fedoraproject.org> - 1.2.0-1
- initial package

